;
; Blink.asm
;
; Created: 07/08/2024 09:56:18
; Author : Lyce PEM

; Blink.asm
; Fait clignoter la LED de la carte Arduino (pdiode T = 2s)

; Dfinir les registres
.equ LED_PIN = 5        ; Broche de la LED (par exemple, PB5 pour la broche 13 sur Arduino Uno)
.equ DELAY_COUNT_EXT = 1000 ; Compteur de la boucke externe ralis avec le mot r27r26
.equ DELAY_COUNT_INT = 4000 ; Compteur de la boucke interne ralis avec le mot r25r24

; Initialisation
.org 0x00
    rjmp RESET          ; Sauter  l'tiquette RESET

RESET:
    ldi r16, (1 << LED_PIN) ; Charger la valeur de la broche LED dans r16
    out DDRB, r16           ; Configurer la broche LED comme sortie

MAIN_LOOP:
    sbi PORTB, LED_PIN      ; Allumer la LED
    rcall DELAY             ; Appeler le sous programme DELAY
    cbi PORTB, LED_PIN      ; teindre la LED
    rcall DELAY             ; Appeler le sous programme DELAY
    rjmp MAIN_LOOP          ; Sauter  l'tiquette MAIN_LOOP (Boucle principale)

DELAY:
    ldi r26, LOW(DELAY_COUNT_INT)  ; Charger l'octet de poids faible dans le compteur de la boucke interne
    ldi r27, HIGH(DELAY_COUNT_INT) ; Charger l'octet de poids fort dans le compteur de la boucke interne
DELAY_LOOP_EXT:
	ldi r24, LOW(DELAY_COUNT_EXT)  ; Charger l'octet de poids faible dans le compteur de la boucke externe
    ldi r25, HIGH(DELAY_COUNT_EXT) ; Charger l'octet de poids fort dans le compteur de la boucke externe 
DELAY_LOOP_INT:
    sbiw r24, 1               ; Dcrmenter le compteur de la boucle interne
    brne DELAY_LOOP_INT       ; Boucler jusqu' ce que le compteur atteigne zro
	sbiw r26, 1               ; Dcrmenter le compteur de la boucle externe
    brne DELAY_LOOP_EXT       ; Boucler jusqu' ce que le compteur atteigne zro
    ret                       ; Retourner  l'appel du sous programme
